﻿using System;
using System.IO;
using System.Linq;
using System.Text;
using HeuristicLab.MainForm.WindowsForms;
using HeuristicLab.Problems.Instances;
using HeuristicLab.Problems.Instances.Views;

namespace HeuristicLab.Problems.GPDL.Views {
  public partial class GpdlEditor : AsynchronousContentView, IProblemInstanceConsumer<string> {
    public GpdlEditor() {
      InitializeComponent();

      viewHost.Content = null; //necessary to enable the change of the ViewType
      viewHost.ViewType = typeof(GpdlProblemInstanceConsumerView);
      viewHost.Content = this;
      ProblemInstanceConsumerView view = (ProblemInstanceConsumerView)viewHost.ActiveView;
      splitContainer.Panel1Collapsed = !view.ProblemInstanceProviders.Any();
    }

    private void compileButton_Click(object sender, EventArgs e) {

      using (var src = new MemoryStream(Encoding.UTF8.GetBytes(codeEditor.textEditor.Text))) {
        Scanner scanner = new Scanner(src);
        Parser parser = new Parser(scanner);
        parser.Parse();
        MainForm.MainFormManager.MainForm.ShowContent(Parser.problem);
      }

      codeEditor.ClearErrors();

      //if (Errors.NumOfErrors() == 0) {
      //  GPDefLex.InitLex();
      //  GPDefSyn.Interpret();

      //} else {
      //  int nLexErrors = Errors.NumOfLexErrors();
      //  for (int i = 0; i < nLexErrors; i++) {
      //    var lexErr = Errors.GetLexError(i == 0);
      //    codeEditor.SetLexError(lexErr.msg, lexErr.line, lexErr.col);
      //  }
      //  int nSynErrors = Errors.NumOfSynErrors();
      //  for (int i = 0; i < nSynErrors; i++) {
      //    var synErr = Errors.GetSynError(i == 0);
      //    codeEditor.SetLexError(synErr.msg, synErr.line, synErr.col);
      //  }
      //}
    }


    void IProblemInstanceConsumer<string>.Load(string data) {
      codeEditor.textEditor.Text = data;
    }
  }
}
