using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;

public class SourceReader {

  private static Regex formalParameterExpr = new Regex(@"\s*,?\s*((?<refOrOut>(out|ref))\s+)?(?<type>[_\w]*)\s+(?<id>[_\w]*)\s*");
  public static IEnumerable<TerminalNode.FieldDefinition> ExtractFormalParameters(string formalParameterSrc) {
    var match = formalParameterExpr.Match(formalParameterSrc);
    var matches = formalParameterExpr.Matches(formalParameterSrc);

    foreach (var m in matches.OfType<Match>()) {
      yield return new TerminalNode.FieldDefinition(m.Groups["refOrOut"].Value, m.Groups["type"].Value, m.Groups["id"].Value);
    }
    //var nParameters = match.Groups["id"].Captures.Count;
    //for (int i = 0; i < nParameters; i++) {
    //  yield return new TerminalNode.FieldDefinition(match.Groups["refOrOut"].Captures[i].Value, match.Groups["type"].Captures[i].Value, match.Groups["id"].Captures[i].Value);
    //}
  }
}
